22def867deeb1c06086d1f785cf406fa42393b0b
[xfstests-dev.git] / tests / xfs / 003
1 #! /bin/bash
2 # FS QA Test No. 003
3 #
4 # exercise xfs_db bug #784078
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2001 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24
25 seq=`basename $0`
26 seqres=$RESULT_DIR/$seq
27 seqres=$RESULT_DIR/$seq
28 seqres=$RESULT_DIR/$seq
29 echo "QA output created by $seq"
30
31 # get standard environment, filters and checks
32 . ./common/rc
33 . ./common/filter
34
35 tmp=/tmp/$$
36 here=`pwd`
37 status=0        # success is the default!
38 trap "rm -f $tmp.*; exit \$status" 0 1 2 3 15
39
40 _need_to_be_root
41
42 # real QA test starts here
43 _supported_fs xfs
44 _supported_os IRIX Linux
45
46 [ -f core ] && rm -f core
47 [ -f core ] && echo "Warning: can't nuke existing core file!"
48
49 test_done()
50 {
51         sts=$?
52         [ -f core ] && echo "FAILED - core file"
53         [ ! -f core -a $sts != 0 ] && echo "FAILED - non-zero exit status"
54         rm -f core
55 }
56
57 # real QA test starts here
58
59 echo "=== TEST 1 ==="
60 xfs_db -r -c 'pop' -c 'type sb' $TEST_DEV
61 test_done
62
63 echo "=== TEST 2 ==="
64 xfs_db -r -c 'push sb' $TEST_DEV
65 test_done
66
67 echo "=== TEST 3 ==="
68 xfs_db -r -c 'pop' -c 'push sb' $TEST_DEV
69 test_done
70
71 echo "=== TEST 4 ==="
72 xfs_db -r -c 'type sb' -c 'print' $TEST_DEV
73 test_done
74
75 echo "=== TEST 5 ==="
76 xfs_db -r -c 'inode 128' -c 'push' -c 'type' $TEST_DEV >$tmp.out 2>&1
77 test_done
78 # On IRIX we lose state after a "push" operation and don't
79 # know the type is still inode
80 # Probably not worth changing xfs_db on IRIX for this.
81 if [ "$HOSTOS" != "IRIX" ]; then
82     if ! grep -q "current type is \"inode\"" $tmp.out
83     then
84             cat $tmp.out
85     fi
86 fi
87
88 echo "=== TEST 6 ==="
89 xfs_db -r -c 'sb' -c 'a' $TEST_DEV >$tmp.out 2>&1 # don't care about output
90 test_done
91
92 echo "=== TEST 7 ==="
93 xfs_db -r -c 'ring' $TEST_DEV
94 test_done